import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/*
<applet code="Fire.class" width=100 height=100>
</applet>
*/

public class Fire extends Applet implements Runnable 
{
	int palette[]=new int[256];
	int frame[][];
	int decay=10;
	int airFlow=2;
	int speed=0;
	int low=0,high=255;
	int w,h;
	Image img;
	public void run()
	{
		int x,y;
		Random r=new Random();
		int tmp,shift,cx;
		while(true)
		{
			for(y=0;y<h-1;++y)
			{
				for(x=0;x<w;++x)
				{
					tmp=frame[y+1][x]-(int)(r.nextFloat()*(float)decay);
					if(tmp<low)
						tmp=low;
					shift=(int)(r.nextFloat()*(float)airFlow);
					if((r.nextInt() % 2)==1)
					{
						cx=x-shift;
						if(cx<0) cx=0;
					}
					else
					{
						cx=x+shift;
						if(cx>w-1) cx=w-1;
					}
					frame[y][cx]=tmp;
				}
			}
			int clr;
			Graphics g=img.getGraphics();
				for(y=0;y<h;++y)
				{
					for(x=0;x<w;++x)
					{
					  clr=palette[frame[y][x]];
					 	g.setColor(new Color((clr>>16)&0xff,(clr>>8)&0xff,clr&0xff));
					 	g.drawLine(x,y,x,y);
					}
				}
				repaint();
			
			try
			{
			
				Thread.sleep(speed);
			}
			catch(Exception e)
			{
				showStatus(e.toString());
			}
		}
	}
	
	public void update(Graphics g)
	{
		paint(g);
	}
	public void paint(Graphics g)
	{
		g.drawImage(img,0,0,w,h,0,0,w,h,this);
	}
	public void init()
	{
		w=getSize().width;
		h=getSize().height;
		img=createImage(w,h);
		frame=new int[h][w];
		initPalette();
		initFrame();
		Thread fireThread=new Thread(this);
		fireThread.start();
	}
	void initPalette()
	{
		for(int i=0;i<51;++i)
			palette[i]=0xff000000|((i*4)<<16)|(int)(i/4)<<8;
		for(int i=51;i<=255;++i)
		{
			palette[i]=0xff000000|(250 << 16)|(i<<8);
		}
	}
	void initFrame()
	{
		int x,y;
		for(x=0;x<w;++x)
			frame[h-1][x]=high;
		for(y=0;y<h-1;++y)
			for(x=0;x<w;++x)
			{
				frame[y][x]=low;
			}
	}
}